(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/forms'), require('shim-keyboard-event-key'), require('moment')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/common', '@angular/forms', 'shim-keyboard-event-key', 'moment'], factory) :
	(factory((global.ng = global.ng || {}, global.ng['utc-datepicker'] = {}),global.ng.core,global.ng.common,global.ng.forms,null,global.moment));
}(this, (function (exports,core,common,forms,shimKeyboardEventKey,moment) { 'use strict';

moment = moment && moment.hasOwnProperty('default') ? moment['default'] : moment;

var __decorate$1 = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (undefined && undefined.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var UtcDatepickerComponent = /** @class */ (function () {
    function UtcDatepickerComponent() {
        var _this = this;
        this.dateChange = new core.EventEmitter();
        this.format = 'YYYY-MM-DD';
        this.button = false;
        this.buttonPosition = 'after'; // either before or after
        this.showCalendar = false;
        this.calendarPosition = 'angular-utc-datepicker_below';
        this.getMomentDate = function (date) {
            if (!moment.utc(date, _this.format).isValid()) {
                date = moment.utc().format(_this.format);
            }
            return moment.utc(date, _this.format);
        };
        this.generateCalendar = function (date) {
            _this.days = [];
            var lastMonth = moment.utc(date).subtract(1, 'M'), nextMonth = moment.utc(date).add(1, 'M'), month = moment.utc(date).month() + 1, year = moment.utc(date).year(), firstWeekDay = 1 - moment.utc(date).startOf('M').isoWeekday(), totalDays = (42 + firstWeekDay) - 1; // 7 columns X 6 rows
            for (var i = firstWeekDay; i <= totalDays; i++) {
                if (i > 0 && i <= moment.utc(date).endOf('M').date()) {
                    // current month
                    _this.days.push({
                        day: i,
                        month: month,
                        year: year,
                        enabled: 'angular-utc-datepicker_enabled',
                        selected: moment.utc(_this.date, _this.format).isSame(moment.utc(year + '-' + month + '-' + i, 'YYYY-M-D'), 'day') ?
                            'angular-utc-datepicker_selected' :
                            'angular-utc-datepicker_unselected'
                    });
                }
                else if (i > moment.utc(date).endOf('M').date()) {
                    // next month
                    _this.days.push({
                        day: i - date.endOf('M').date(),
                        month: nextMonth.month() + 1,
                        year: nextMonth.year(),
                        enabled: 'angular-utc-datepicker_disabled',
                        selected: 'angular-utc-datepicker_unselected'
                    });
                }
                else {
                    // last month
                    _this.days.push({
                        day: lastMonth.endOf('M').date() - (0 - i),
                        month: lastMonth.month() + 1,
                        year: lastMonth.year(),
                        enabled: 'angular-utc-datepicker_disabled',
                        selected: 'angular-utc-datepicker_unselected'
                    });
                }
            }
        };
        this.generateDayNames = function () {
            var date = moment('2017-04-02'); // sunday
            for (var i = 0; i < 7; i++) {
                _this.dayNames.push(date.format('ddd'));
                date.add('1', 'd');
            }
        };
        this.openCalendar = function (event) {
            var rect = event.target.getBoundingClientRect();
            _this.calendarPosition = window.innerHeight - rect.bottom < 250 ? 'angular-utc-datepicker_above' : 'angular-utc-datepicker_below';
            _this.showCalendar = true;
            _this.generateCalendar(_this.getMomentDate(_this.tempDate));
        };
        this.closeCalendar = function () {
            setTimeout(function () {
                if (document.activeElement) {
                    _this.showCalendar = document.activeElement.className.includes('angular-utc-datepicker_calendar-popup') ||
                        document.activeElement.className.includes('angular-utc-datepicker_input');
                    if (!_this.showCalendar) {
                        _this.calendarTitle = _this.getMomentDate(_this.date).format('MMMM YYYY');
                        _this.tempDate = _this.getMomentDate(_this.date);
                        if (_this.inputText && _this.inputText !== _this.date) {
                            _this.el.nativeElement.value = _this.date;
                        }
                    }
                }
            }, 50);
        };
        this.prevMonth = function () {
            _this.tempDate.subtract(1, 'M');
            _this.calendarTitle = _this.tempDate.format('MMMM YYYY');
            _this.generateCalendar(_this.tempDate);
        };
        this.nextMonth = function () {
            _this.tempDate.add(1, 'M');
            _this.calendarTitle = _this.tempDate.format('MMMM YYYY');
            _this.generateCalendar(_this.tempDate);
        };
        this.selectDate = function (date) {
            var currDate = moment.utc(_this.date, _this.format);
            var selectedDate = moment.utc(date.year + "-" + date.month + "-" + date.day + " " + currDate.hour() + ":" + currDate.minute() + ":\n            " + currDate.second(), 'YYYY-M-D HH:mm:ss');
            _this.date = selectedDate.format(_this.format);
            _this.tempDate = _this.getMomentDate(_this.date);
            _this.calendarTitle = _this.tempDate.format('MMMM YYYY');
            _this.generateCalendar(_this.tempDate);
            _this.dateChange.emit(_this.date);
            _this.showCalendar = false;
        };
        this.selectToday = function () {
            var today = moment.utc();
            var date = {
                day: today.date(),
                month: today.month() + 1,
                year: today.year(),
                enabled: 'angular-utc-datepicker_enabled',
                selected: 'angular-utc-datepicker_selected'
            };
            _this.selectDate(date);
        };
        this.keydown = function (event) {
            if (event.key === 'Escape') {
                _this.showCalendar = false;
            }
        };
        this.onDateChange = function (value) {
            _this.inputText = value;
            var isValid = moment.utc(value, _this.format).format(_this.format) === value;
            if (isValid) {
                _this.date = value;
                _this.calendarTitle = moment.utc(value, _this.format).format('MMMM YYYY');
                _this.generateCalendar(_this.getMomentDate(value));
                _this.dateChange.emit(_this.date);
            }
        };
        this.days = [];
        this.dayNames = [];
    }
    UtcDatepickerComponent.prototype.ngOnInit = function () {
        if (typeof this.date === 'object') {
            // date was passed in as a JS Date object
            this.date = moment.utc(this.date).format(this.format);
        }
        else {
            var isValid = moment.utc(this.date, this.format).format(this.format) === this.date;
            if (!isValid) {
                // date does not match format, so try to force it
                this.date = moment.utc(this.date).format(this.format);
                if (!moment.utc(this.date).isValid()) {
                    // moment is unable to parse the string
                    throw new Error('Invalid date string specified');
                }
            }
        }
        this.calendarTitle = this.getMomentDate(this.date).format('MMMM YYYY');
        this.tempDate = this.getMomentDate(this.date);
        if (this.dayNames.length === 0) {
            this.generateDayNames();
        }
    };
    __decorate$1([
        core.Input(),
        __metadata("design:type", String)
    ], UtcDatepickerComponent.prototype, "date", void 0);
    __decorate$1([
        core.Output(),
        __metadata("design:type", Object)
    ], UtcDatepickerComponent.prototype, "dateChange", void 0);
    __decorate$1([
        core.Input(),
        __metadata("design:type", Object)
    ], UtcDatepickerComponent.prototype, "format", void 0);
    __decorate$1([
        core.Input(),
        __metadata("design:type", Object)
    ], UtcDatepickerComponent.prototype, "button", void 0);
    __decorate$1([
        core.Input(),
        __metadata("design:type", Object)
    ], UtcDatepickerComponent.prototype, "buttonPosition", void 0);
    __decorate$1([
        core.ViewChild('dateInput'),
        __metadata("design:type", core.ElementRef)
    ], UtcDatepickerComponent.prototype, "el", void 0);
    UtcDatepickerComponent = __decorate$1([
        core.Component({
            selector: 'utc-datepicker',
            template: "\n        <button class=\"angular-utc-datepicker_button\" (click)=\"openCalendar($event)\" *ngIf=\"button && buttonPosition === 'before'\"\n                (blur)=\"closeCalendar()\" (keydown)=\"keydown($event)\">\n            <i class=\"fa fa-calendar\"></i>\n        </button>\n        <input #dateInput class=\"angular-utc-datepicker_input\" [ngModel]=\"date\" (ngModelChange)=\"onDateChange($event)\"\n               (focus)=\"openCalendar($event)\" (blur)=\"closeCalendar()\" (keydown)=\"keydown($event)\">\n        <button class=\"angular-utc-datepicker_button\" (click)=\"openCalendar($event)\" *ngIf=\"button && buttonPosition === 'after'\"\n                (blur)=\"closeCalendar()\" (keydown)=\"keydown($event)\">\n            <i class=\"fa fa-calendar\"></i>\n        </button>\n        <div class=\"angular-utc-datepicker_datepicker\">\n            <div class=\"angular-utc-datepicker_calendar-popup\" ngClass=\"calendarPosition\" [hidden]=\"!showCalendar\"\n                 (blur)=\"closeCalendar()\" (keydown)=\"keydown($event)\" tabindex=\"0\">\n                <div class=\"angular-utc-datepicker_calendar-controls\">\n                    <div class=\"angular-utc-datepicker_prev\" (click)=\"prevMonth()\" (keydown)=\"keydown($event)\">\n                        <i class=\"fa fa-arrow-left\"></i>\n                    </div>\n                    <div class=\"angular-utc-datepicker_title\">\n                        {{calendarTitle}} <span class=\"angular-utc-datepicker_today\" title=\"Today\" (click)=\"selectToday()\"\n                                                  (keydown)=\"keydown($event)\"><i class=\"fa fa-calendar-o\"></i></span>\n                    </div>\n                    <div class=\"angular-utc-datepicker_next\" (click)=\"nextMonth()\" (keydown)=\"keydown($event)\">\n                        <i class=\"fa fa-arrow-right\"></i>\n                    </div>\n                </div>\n                <div class=\"angular-utc-datepicker_day-names\">\n                    <div class=\"angular-utc-datepicker_name\" *ngFor=\"let name of dayNames\">{{name}}</div>\n                </div>\n                <div class=\"angular-utc-datepicker_calendar\">\n                    <div class=\"angular-utc-datepicker_day {{day.selected}} {{day.enabled}}\" *ngFor=\"let day of days\"\n                         (click)=\"selectDate(day)\">\n                        {{day.day}}\n                    </div>\n                    <div class=\"angular-utc-datepicker_clear\"></div>\n                </div>\n            </div>\n        </div>\n    ",
            styles: ["\n        .angular-utc-datepicker_input {\n            padding: 5px;\n        }\n        .angular-utc-datepicker_button {\n            padding: 7px;\n        }\n        .angular-utc-datepicker_datepicker {\n            position: absolute;\n            top: auto;\n            left: auto;\n            z-index: 1000;\n        }\n        .angular-utc-datepicker_datepicker .angular-utc-datepicker_calendar-icon {\n            cursor: pointer;\n        }\n        .angular-utc-datepicker_datepicker .angular-utc-datepicker_calendar-popup {\n            width: 245px;\n            opacity: 0.9;\n            border-left: 1px solid #888;\n        }\n        .angular-utc-datepicker_datepicker .angular-utc-datepicker_calendar-popup.angular-utc-datepicker_above {\n            margin-top: -293px;\n        }\n        .angular-utc-datepicker_datepicker .angular-utc-datepicker_calendar-popup.angular-utc-datepicker_below {\n            margin-top: 5px;\n        }\n        .angular-utc-datepicker_datepicker .angular-utc-datepicker_calendar-popup .angular-utc-datepicker_calendar-controls {\n            box-sizing: border-box;\n            background: #ccc;\n            width: 100%;\n            padding: 5px 0;\n            text-align: center;\n            color: #000;\n            border-top: 1px solid #888;\n            border-right: 1px solid #888;\n            display: flex;\n            justify-content: space-between;\n        }\n        .angular-utc-datepicker_datepicker .angular-utc-datepicker_calendar-popup .angular-utc-datepicker_calendar-controls .angular-utc-datepicker_prev,\n        .angular-utc-datepicker_datepicker .angular-utc-datepicker_calendar-popup .angular-utc-datepicker_calendar-controls .angular-utc-datepicker_next,\n        .angular-utc-datepicker_datepicker .angular-utc-datepicker_calendar-popup .angular-utc-datepicker_calendar-controls .angular-utc-datepicker_today {\n            cursor: pointer;\n            padding: 0 7px;\n        }\n        .angular-utc-datepicker_datepicker .angular-utc-datepicker_calendar-popup .angular-utc-datepicker_day-names {\n            background: #555;\n            color: #fff;\n            display: flex;\n        }\n        .angular-utc-datepicker_datepicker .angular-utc-datepicker_calendar-popup .angular-utc-datepicker_day-names .angular-utc-datepicker_name {\n            width: 35px;\n            height: 15px;\n            padding: 1px;\n            text-align: center;\n        }\n        .angular-utc-datepicker_datepicker .angular-utc-datepicker_calendar-popup .angular-utc-datepicker_calendar {\n            background: #fff;\n            width: 245px;\n        }\n        .angular-utc-datepicker_datepicker .angular-utc-datepicker_calendar-popup .angular-utc-datepicker_calendar .angular-utc-datepicker_day {\n            box-sizing: border-box;\n            width: 35px;\n            height: 35px;\n            display: inline-block;\n            float: left;\n            padding: 2px;\n            border-right: 1px solid #888;\n            border-bottom: 1px solid #888;\n            color: #000;\n            background: #fff;\n        }\n        .angular-utc-datepicker_datepicker .angular-utc-datepicker_calendar-popup .angular-utc-datepicker_calendar .angular-utc-datepicker_day:hover {\n            background: #ccc;\n            color: #000;\n            cursor: pointer;\n        }\n        .angular-utc-datepicker_datepicker .angular-utc-datepicker_calendar-popup .angular-utc-datepicker_calendar .angular-utc-datepicker_day:last-child {\n            border-right: 1px solid #888;\n        }\n        .angular-utc-datepicker_datepicker .angular-utc-datepicker_calendar-popup .angular-utc-datepicker_calendar .angular-utc-datepicker_selected {\n            background: #42a5f5;\n            color: #fff;\n        }\n        .angular-utc-datepicker_datepicker .angular-utc-datepicker_calendar-popup .angular-utc-datepicker_calendar .angular-utc-datepicker_disabled {\n            background: #ddd;\n            color: #555;\n        }\n        .angular-utc-datepicker_clear {\n            clear: both;\n        }\n\n    "]
        }),
        __metadata("design:paramtypes", [])
    ], UtcDatepickerComponent);
    return UtcDatepickerComponent;
}());

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var UtcDatepickerModule = /** @class */ (function () {
    function UtcDatepickerModule() {
    }
    UtcDatepickerModule = __decorate([
        core.NgModule({
            imports: [
                common.CommonModule,
                forms.FormsModule
            ],
            providers: [],
            declarations: [UtcDatepickerComponent],
            exports: [UtcDatepickerComponent]
        })
    ], UtcDatepickerModule);
    return UtcDatepickerModule;
}());

exports.UtcDatepickerModule = UtcDatepickerModule;
exports.UtcDatepickerComponent = UtcDatepickerComponent;

Object.defineProperty(exports, '__esModule', { value: true });

})));
